#!/usr/local/bin/perl -w
#
# FNET/ICB CLIENT 1.1   11/18/96
# John M Vinopal        banshee@resort.com
#
# Copyright (C) 1996, The Resort, All Rights Reserved.
# Permission is granted to copy and modify this program for
# non-commercial purposes, so long as this copyright notice is
# preserved.  This software is distributed without warranty.
#

package CMDLINE;

use POSIX;
#use strict;
#use diagnostics;

sub	cmdline
{
my ($EOL, $os) = @_;
my ($line, $linelen, $ch, $backspace);
$line = "";
$linelen = 0;
$backspace = 0;

#system('stty raw');
while (1) {
	while (($ch = getc()) eq "") {;}
	$backspace = 0;
	
	if (not iscntrl($ch)) {			# Add a normal character.
		if ($linelen == 200) {		# A finite input buffer.
			print "\007";
		} else {
			$line = $line.$ch;
			$linelen++;
			print $ch;
		}
	} else {
		my $ordch = ord($ch);
		if ($ordch == 3) {		# Ctrl-c.
			if ($linelen == 0) {
				print "^c: use /quit$EOL";
				goto EXIT;
			}
			$line = "";
			$backspace = $linelen;
		} elsif ($ordch == 8) {		# Ctrl-h
			if ($linelen == 0) {
				goto EXIT;
			}
			$line = substr($line, 0, $linelen-1);
			$backspace = 1;
		} elsif ($ordch == 9) {		# Ctrl-i. Tab.
			if ($linelen == 0) {
				print "<Not Enabled>$EOL";
				goto EXIT;
			} 
			print "\007";
		} elsif ($ordch == 10) {	# Ctrl-j. NL.
			goto EXIT;
		} elsif ($ordch == 13) {	# Ctrl-m. Return.
			goto EXIT;
		} elsif ($ordch == 18) {	# Ctrl-r
			if ($linelen == 0) {
				goto EXIT;
			}
			print "$EOL";
			print $line;
		} elsif ($ordch == 21) {	# Ctrl-u
			if ($linelen == 0) {
				goto EXIT;
			}
			$line = "";
			$backspace = $linelen;
		} elsif ($ordch == 23) {	# Ctrl-w
			if ($linelen == 0) {
				goto EXIT;
			}
			my $pos = $linelen-1;
			while ($pos >= 0 and &isspace(substr($line, $pos, 1))) {
				$backspace++;
				$pos--;
			}
			while ($pos >= 0 and not &isspace(substr($line, $pos, 1))) {
				$backspace++;
				$pos--;
			}
		} elsif ($ordch == 26) {	# Ctrl-z
			if ($os eq "Unix") {
				kill 'TSTP', $$;
			} else {
				print "\007";
			}
		} else {			# Beep and complain.
			if ($linelen == 0) {
				goto EXIT;
			}
			print "Bad Char: $ordch";
		}
		if ($linelen > 0) {
			while ($backspace > 0) {  # Remove chars from screen.
				print "\010\040\010";
				$backspace--;
				$linelen--;
				if ($linelen == 0) {
					$line = "";
					goto EXIT;
				}
			}
			$line = substr($line, 0, $linelen);
		}
	}
}
EXIT:
if ($linelen == 0) {
	print "\007";
}
#system('stty -raw');
return($line);
}

1;
